## galera-3 25.3.10

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2014 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = platform.architecture()[0]
print 'Host: ' + sysname + ' ' + machine + ' ' + bits

x86 = 0
if bits == '32bit':
    x86 = 32
elif bits == '64bit':
    x86 = 64


#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n             debug build with optimization level n
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'


if x86 == 32:
    compile_arch = ' -m32 -march=i686'
    link_arch    = compile_arch
    if sysname == 'linux':
        link_arch = link_arch + ' -Wl,-melf_i386'
elif x86 == 64 and sysname != 'sunos':
    compile_arch = ' -m64'
    link_arch    = compile_arch
    if sysname == 'linux':
        link_arch = link_arch + ' -Wl,-melf_x86_64'
elif machine == 'ppc64':
    compile_arch = ' -mtune=native'
    link_arch    = ''
elif sysname == 'sunos':
    compile_arch = ' -mtune=native'
    link_arch    = ''
else:
    compile_arch = ''
    link_arch    = ''


boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
ssl        = int(ARGUMENTS.get('ssl', 1))
tests      = int(ARGUMENTS.get('tests', 1))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))


GALERA_VER = ARGUMENTS.get('version', '3.10')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')

# Attempt to read from file if not given
if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
    with open("GALERA_REVISION", "r") as f:
        GALERA_REV = f.readline().rstrip("\n")

# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CPPFLAGS = ' -pthread')

# Freebsd ports are installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH  = ['/usr/local/lib'])
    env.Append(CPPFLAGS = ' -I/usr/local/include ')
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()
#
# Set up build and link paths
#

# Include paths
env.Append(CPPPATH = Split('''#
                              #/asio
                              #/common
                              #/galerautils/src
                              #/gcomm/src
                              #/gcomm/src/gcomm
                              #/gcache/src
                              #/gcs/src
                              #/wsdb/src
                              #/galera/src
                           '''))

# Library paths
#env.Append(LIBPATH = Split('''#/galerautils/src
#                              #/gcomm/src
#                              #/gcs/src
#                              #/wsdb/src
#                              #/galera/src
#                           '''))

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Replace(CCFLAGS = opt_flags + compile_arch +
                      ' -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
if sysname != 'sunos':
    env.Append(CXXFLAGS = ' -pipe')


# Linker flags
# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
env.Append(LINKFLAGS = link_arch)

#
# Check required headers and libraries (autoconf functionality)
#

conf = Configure(env)

# System headers and libraries

if not conf.CheckLib('pthread'):
    print 'Error: pthread library not found'
    Exit(1)

# libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
# for 8 byte atomics but not generally required
if 0 == x86:
    conf.CheckLib('atomic')

if sysname != 'darwin':
    if not conf.CheckLib('rt'):
        print 'Error: rt library not found'
        Exit(1)

if sysname == 'freebsd':
    if not conf.CheckLib('execinfo'):
        print 'Error: execinfo library not found'
        Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print 'Error: socket library not found'
        Exit(1)
    if not conf.CheckLib('crypto'):
        print 'Error: crypto library not found'
        Exit(1)
    if not conf.CheckLib('nsl'):
        print 'Error: nsl library not found'
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ENDIAN_H')
elif conf.CheckHeader('sys/endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_ENDIAN_H')
elif conf.CheckHeader('sys/byteorder.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_BYTEORDER_H')
elif sysname != 'darwin':
    print 'can\'t find byte order information'
    Exit(1)

# Additional C headers and libraries

# boost headers

if not conf.CheckCXXHeader('boost/shared_ptr.hpp'):
    print 'boost/shared_ptr.hpp not found or not usable'
    Exit(1)
conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_SHARED_PTR_HPP')

if conf.CheckCXXHeader('unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_UNORDERED_MAP')
elif conf.CheckCXXHeader('tr1/unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_TR1_UNORDERED_MAP')
else:
    if conf.CheckCXXHeader('boost/unordered_map.hpp'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_UNORDERED_MAP_HPP')
    else:
        print 'no unordered map header available'
        Exit(1)

# pool allocator
if boost == 1:
    # Default suffix for boost multi-threaded libraries
    if sysname == 'darwin':
        boost_library_suffix = '-mt'
    else:
        boost_library_suffix = ''
    if sysname == 'darwin' and extra_sysroot != '':
        boost_library_path = extra_sysroot + '/lib'
    else:
        boost_library_path = ''
    # Use nanosecond time precision
    conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
    # Common procedure to find boost static library
    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
    def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
        libName = libBaseName + boost_library_suffix
        if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
            print "Error: file '%s' does not exist" % configuredLibPath
            Exit(1)
        if configuredLibPath == '':
           for libpath in boost_libpaths:
               libname = libpath + '/lib%s.a' % libName
               if os.path.isfile(libname):
                   configuredLibPath = libname
                   break
        if configuredLibPath != '':
            if not conf.CheckCXXHeader(header):
                print "Error: header '%s' does not exist" % header
                Exit (1)
            if autoadd:
                conf.env.Append(LIBS=File(configuredLibPath))
            else:
                return File(configuredLibPath)
        else:
            if not conf.CheckLibWithHeader(libs=[libName],
                                           header=header,
                                           language='CXX',
                                           autoadd=autoadd):
                print 'Error: library %s does not exist' % libName
                Exit (1)
            return [libName]
    # Required boost headers/libraries
    #
    if boost_pool == 1:
        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
            print 'Using boost pool alloc'
            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
            # due to a bug in boost >= 1.50 we need to link with boost_system
            # - should be a noop with no boost_pool.
            if sysname == 'darwin':
                if conf.CheckLib('boost_system' + boost_library_suffix):
                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
            check_boost_library('boost_system',
                                'boost/system/error_code.hpp',
                                LIBBOOST_SYSTEM_A)
        else:

=== debian/changelog ===
galera-3 (25.3.10-1ubuntu1) wily; urgency=medium

  * Build with -Wno-error=pedantic.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 21:49:36 +0200

galera-3 (25.3.10-1) unstable; urgency=low

  * Initial upload (Closes: #562666)

 -- Otto Kekäläinen <otto@seravo.fi>  Fri, 01 May 2015 20:15:51 +0300

=== debian/control ===
Source: galera-3
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@seravo.fi>
Section: database
Priority: optional
Standards-Version: 3.9.6
Build-Depends: check,
               debhelper (>= 9),
               libboost-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev,
               scons (>= 2)
Homepage: http://www.galeracluster.com/
Vcs-Git: git://anonscm.debian.org/pkg-mysql/galera-3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git

Package: galera-3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: garbd-2,
           garbd2,
           percona-galera-3,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x,
           galera
Provides: galera-3,
          wsrep,
          galera,
          galera3,
          percona-xtradb-cluster-galera-25
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-3-dbg
Architecture: any
Section: debug
Priority: extra
Depends: galera-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-3
 This package contains the debugging symbols for galera-3.

Package: galera-arbitrator-3
Architecture: any
Conflicts: garbd-2, garbd2, percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: netcat-openbsd, ${misc:Depends}, ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

Package: galera-arbitrator-3-dbg
Architecture: any
Section: debug
Priority: extra
Conflicts: percona-xtradb-cluster-galera-2.x-dbg
Depends: galera-arbitrator-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-arbitrator-3
 This package contains the debugging symbols for galera-arbitrator-3.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# Parallel build support as adviced
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += -j $(NUMJOBS)
	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
endif

# Add support for verbose builds
ifneq (,$(filter verbose,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += VERBOSE=1
endif

# Run tests by default
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += tests=1
endif


override_dh_auto_build:
	@echo $(SCONS_ARGS)
	scons $(SCONS_ARGS)

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit --name=garb -- defaults 18 22

override_dh_strip:
	dh_strip -pgalera-3 --dbg-package=galera-3-dbg
	dh_strip -pgalera-arbitrator-3 --dbg-package=galera-arbitrator-3-dbg

%:
	dh $@

.PHONY: override_dh_strip

## galera-3 25.3.12

=== debian/changelog ===
galera-3 (25.3.12-3) unstable; urgency=low

  * Update patches with proper DEP-3 compliant headers
  * Add patch to fix build error after SSLv3 deprication (Closes: #804336)

 -- Otto Kekäläinen <otto@seravo.fi>  Fri, 13 Nov 2015 15:41:29 +0200

galera-3 (25.3.12-2) unstable; urgency=low

  * Backport upstream commit as patch to fix multiple build problems
    (Closes: #799150)
  * Backport upstream commit as patch to fix x32 build problems

 -- Otto Kekäläinen <otto@seravo.fi>  Sun, 20 Sep 2015 23:27:16 +0300

galera-3 (25.3.12-1) unstable; urgency=low

  * Import new upstream release
    - Fixes GCC 5 building and PRETTY_FUNCTION error (Closes: #797238)
    - Fixes for pthread build issues on different platforms
  * Add lintian override as garbd is intentionally not started upon installation
  * Print in build log env info to help debug builds on different platforms
  * Update gdb.conf to have tags signed by default
  * Print config.log contents in build log for easier debugging of Debian builds
  * Print config.log if build fails

 -- Otto Kekäläinen <otto@seravo.fi>  Sun, 06 Sep 2015 20:45:43 +0300

=== debian/control ===
--- 
+++ 
@@ -25,13 +25,13 @@
            percona-xtradb-cluster-galera-2.x,
            percona-xtradb-cluster-galera-3.x,
            percona-xtradb-cluster-garbd-2.x,
-           percona-xtradb-cluster-garbd-3.x,
-           galera
-Provides: galera-3,
-          wsrep,
+           percona-xtradb-cluster-garbd-3.x
+Provides: wsrep,
           galera,
           galera3,
           percona-xtradb-cluster-galera-25
+Breaks: galera
+Replaces: galera
 Description: Replication framework for transactional applications
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
@@ -53,7 +53,7 @@
 Conflicts: garbd-2, garbd2, percona-xtradb-cluster-garbd-2.x
 Breaks: percona-xtradb-cluster-galera-2.x
 Replaces: percona-xtradb-cluster-galera-2.x
-Depends: netcat-openbsd, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Galera arbitrator daemon
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information

## galera-3 25.3.13

=== debian/changelog ===
galera-3 (25.3.13-2) unstable; urgency=low

  * Added libasio-dev as build dependency. The new upstream SConscript will
    automatically use system ASIO if the provided version is recent enough
    (Closes: #804336).
  * Make GFDL link explicit and other Lintian fixes
  * Update git-buildpackage config to allow fix branches etc

 -- Otto Kekäläinen <otto@seravo.fi>  Thu, 31 Dec 2015 23:45:17 +0200

galera-3 (25.3.13-1) unstable; urgency=low

  * Import new upstream release and drop patches that have become obsolete

 -- Otto Kekäläinen <otto@seravo.fi>  Fri, 27 Nov 2015 22:48:00 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,8 @@
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
                libssl-dev,
-               scons (>= 2)
+               scons (>= 2),
+               libasio-dev
 Homepage: http://www.galeracluster.com/
 Vcs-Git: git://anonscm.debian.org/pkg-mysql/galera-3.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git

## galera-3 25.3.14

=== SConstruct ===
--- 
+++ 
@@ -1,8 +1,18 @@
 ###################################################################
 #
-# Copyright (C) 2010-2014 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2015 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
+#
+# How to control the build with environment variables:
+# Set CC       to specify C compiler
+# Set CXX      to specify C++ compiler
+# Set CPPFLAGS to add non-standard include paths and preprocessor macros
+# Set CCFLAGS  to *override* optimization and architecture-specific options
+# Set CFLAGS   to supply C compiler options
+# Set CXXFLAGS to supply C++ compiler options
+# Set LDFLAGS  to *override* linking flags
+# Set LIBPATH  to add non-standard linker paths
 #
 # Script structure:
 # - Help message
@@ -20,15 +30,15 @@
 
 sysname = os.uname()[0].lower()
 machine = platform.machine()
-bits = platform.architecture()[0]
+bits = ARGUMENTS.get('bits', platform.architecture()[0])
 print 'Host: ' + sysname + ' ' + machine + ' ' + bits
 
-x86 = 0
+x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386' ])
+
 if bits == '32bit':
-    x86 = 32
+    bits = 32
 elif bits == '64bit':
-    x86 = 64
-
+    bits = 64
 
 #
 # Print Help
@@ -46,6 +56,7 @@
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
+    bits=[32bit|64bit]
 ''')
 # bpostatic option added on Percona request
 
@@ -86,27 +97,25 @@
 if dbug:
     opt_flags = opt_flags + ' -DGU_DBUG_ON'
 
-
-if x86 == 32:
-    compile_arch = ' -m32 -march=i686'
-    link_arch    = compile_arch
-    if sysname == 'linux':
-        link_arch = link_arch + ' -Wl,-melf_i386'
-elif x86 == 64 and sysname != 'sunos':
-    compile_arch = ' -m64'
-    link_arch    = compile_arch
-    if sysname == 'linux':
-        link_arch = link_arch + ' -Wl,-melf_x86_64'
-elif machine == 'ppc64':
+if sysname == 'sunos':
     compile_arch = ' -mtune=native'
-    link_arch    = ''
-elif sysname == 'sunos':
-    compile_arch = ' -mtune=native'
-    link_arch    = ''
-else:
-    compile_arch = ''
-    link_arch    = ''
-
+elif x86:
+    if bits == 32:
+        if machine == 'x86_64':
+            compile_arch = ' -mx32'
+        else:
+            compile_arch = ' -m32 -march=i686'
+            if sysname == 'linux':
+                link_arch = ' -Wl,-melf_i386'
+    else:
+        compile_arch = ' -m64'
+        if sysname == 'linux':
+            link_arch = ' -Wl,-melf_x86_64'
+    link_arch = compile_arch + link_arch
+elif machine == 's390x':
+    compile_arch = ' -mzarch -march=z196 -mtune=zEC12'
+    if bits == 32:
+        compile_arch += ' -m32'
 
 boost      = int(ARGUMENTS.get('boost', 1))
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
@@ -115,7 +124,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.10')
+GALERA_VER = ARGUMENTS.get('version', '3.14')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -157,12 +166,16 @@
     env.Replace(LINK = link)
 
 # Initialize CPPFLAGS and LIBPATH from environment to get user preferences
-env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
-env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])
+env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
+env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
+env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
+env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
+env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
+env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
 
 # Set -pthread flag explicitly to make sure that pthreads are
 # enabled on all platforms.
-env.Append(CPPFLAGS = ' -pthread')
+env.Append(CCFLAGS = ' -pthread')
 
 # Freebsd ports are installed under /usr/local
 if sysname == 'freebsd' or sysname == 'sunos':
@@ -186,30 +199,6 @@
     env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')
 
 # print env.Dump()
-#
-# Set up build and link paths
-#
-
-# Include paths
-env.Append(CPPPATH = Split('''#
-                              #/asio
-                              #/common
-                              #/galerautils/src
-                              #/gcomm/src
-                              #/gcomm/src/gcomm
-                              #/gcache/src
-                              #/gcs/src
-                              #/wsdb/src
-                              #/galera/src
-                           '''))
-
-# Library paths
-#env.Append(LIBPATH = Split('''#/galerautils/src
-#                              #/gcomm/src
-#                              #/gcs/src
-#                              #/wsdb/src
-#                              #/galera/src
-#                           '''))
 
 # Preprocessor flags
 if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
@@ -220,31 +209,57 @@
 
 # Common C/CXX flags
 # These should be kept minimal as they are appended after C/CXX specific flags
-env.Replace(CCFLAGS = opt_flags + compile_arch +
-                      ' -Wall -Wextra -Wno-unused-parameter')
+env.Append(CCFLAGS = ' -Wall -Wextra -Wno-unused-parameter')
 
 # C-specific flags
-env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
+env.Append(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
 
 # CXX-specific flags
 # Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
 #       adding those after checks
-env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
+env.Append(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
 if sysname != 'sunos':
     env.Append(CXXFLAGS = ' -pipe')
 
 
 # Linker flags
-# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
+# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
 # static linking have beed addressed
 #
-env.Append(LINKFLAGS = link_arch)
+#env.Append(LINKFLAGS = ' -Wl,--warn-common -Wl,--fatal-warnings')
 
 #
 # Check required headers and libraries (autoconf functionality)
 #
 
-conf = Configure(env)
+#
+# Custom tests:
+#
+
+def CheckSystemASIOVersion(context):
+    system_asio_test_source_file = """
+#include <asio.hpp>
+
+#if ASIO_VERSION < 101001
+#error "Included asio version is too old"
+#endif
+
+int main()
+{
+    return 0;
+}
+
+"""
+    context.Message('Checking ASIO version (> 1.10.1) ... ')
+    result = context.TryLink(system_asio_test_source_file, '.cpp')
+    context.Result(result)
+    return result
+
+
+#
+# Construct confuration context
+#
+conf = Configure(env, custom_tests = {'CheckSystemASIOVersion': CheckSystemASIOVersion})
 
 # System headers and libraries
 
@@ -254,7 +269,7 @@
 
 # libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
 # for 8 byte atomics but not generally required
-if 0 == x86:
+if not x86:
     conf.CheckLib('atomic')
 
 if sysname != 'darwin':
@@ -294,6 +309,9 @@
     print 'can\'t find byte order information'
     Exit(1)
 
+if conf.CheckHeader('execinfo.h'):
+    conf.env.Append(CPPFLAGS = ' -DHAVE_EXECINFO_H')
+
 # Additional C headers and libraries
 
 # boost headers
@@ -327,8 +345,13 @@
         boost_library_path = ''
     # Use nanosecond time precision
     conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
+
     # Common procedure to find boost static library
-    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
+    if bits == 64:
+        boost_libpaths = [ boost_library_path, '/usr/lib64', '/usr/local/lib64' ]
+    else:
+        boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/lib' ]
+
     def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
         libName = libBaseName + boost_library_suffix
         if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
@@ -356,18 +379,6 @@
                 print 'Error: library %s does not exist' % libName
                 Exit (1)
             return [libName]
+
     # Required boost headers/libraries
     #
-    if boost_pool == 1:
-        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
-            print 'Using boost pool alloc'
-            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
-            # due to a bug in boost >= 1.50 we need to link with boost_system
-            # - should be a noop with no boost_pool.
-            if sysname == 'darwin':
-                if conf.CheckLib('boost_system' + boost_library_suffix):
-                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
-            check_boost_library('boost_system',
-                                'boost/system/error_code.hpp',
-                                LIBBOOST_SYSTEM_A)
-        else:

=== debian/changelog ===
galera-3 (25.3.14-1) unstable; urgency=low

  * New upstream release
  * Ran wrap-and-sort

 -- Otto Kekäläinen <otto@seravo.fi>  Sun, 07 Feb 2016 22:09:15 +0200

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
 Standards-Version: 3.9.6
 Build-Depends: check,
                debhelper (>= 9),
+               libasio-dev,
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
                libssl-dev,
-               scons (>= 2),
-               libasio-dev
+               scons (>= 2)
 Homepage: http://www.galeracluster.com/
 Vcs-Git: git://anonscm.debian.org/pkg-mysql/galera-3.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git
@@ -27,10 +27,7 @@
            percona-xtradb-cluster-galera-3.x,
            percona-xtradb-cluster-garbd-2.x,
            percona-xtradb-cluster-garbd-3.x
-Provides: wsrep,
-          galera,
-          galera3,
-          percona-xtradb-cluster-galera-25
+Provides: galera, galera3, percona-xtradb-cluster-galera-25, wsrep
 Breaks: galera
 Replaces: galera
 Description: Replication framework for transactional applications

=== debian/watch ===
version=3
http://releases.galeracluster.com/source/galera-3-(.+).tar.gz

## galera-3 25.3.16

=== SConstruct ===
--- 
+++ 
@@ -113,7 +113,7 @@
             link_arch = ' -Wl,-melf_x86_64'
     link_arch = compile_arch + link_arch
 elif machine == 's390x':
-    compile_arch = ' -mzarch -march=z196 -mtune=zEC12'
+    compile_arch = ' -mzarch'
     if bits == 32:
         compile_arch += ' -m32'
 
@@ -124,7 +124,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.14')
+GALERA_VER = ARGUMENTS.get('version', '3.16')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -382,3 +382,4 @@
 
     # Required boost headers/libraries
     #
+    if boost_pool == 1:

=== debian/changelog ===
galera-3 (25.3.16-1) unstable; urgency=low

  * New upstream release

 -- Otto Kekäläinen <otto@debian.org>  Mon, 30 May 2016 23:28:41 +0300

galera-3 (25.3.15-1) unstable; urgency=low

  * New upstream release
    - Remove all obsolete patches

 -- Otto Kekäläinen <otto@debian.org>  Wed, 16 Mar 2016 20:37:10 +0200

galera-3 (25.3.14-2~exp1) experimental; urgency=low

  * Update standards version, vcs-link to use https and maintainer e-mail
  * Add patch to fix build regression on s390x

 -- Otto Kekäläinen <otto@debian.org>  Sun, 06 Mar 2016 00:09:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: galera-3
 Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
-Uploaders: Otto Kekäläinen <otto@seravo.fi>
+Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends: check,
                debhelper (>= 9),
                libasio-dev,
@@ -13,7 +13,7 @@
                scons (>= 2)
 Homepage: http://www.galeracluster.com/
 Vcs-Git: git://anonscm.debian.org/pkg-mysql/galera-3.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git
 
 Package: galera-3
 Architecture: any

## galera-3 25.3.19

=== SConstruct ===
--- 
+++ 
@@ -124,7 +124,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.16')
+GALERA_VER = ARGUMENTS.get('version', '3.19')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given

=== debian/changelog ===
galera-3 (25.3.19-2ubuntu4) zesty; urgency=medium

  * Yet another round of fixes for armhf.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 20 Feb 2017 23:18:20 -0800

galera-3 (25.3.19-2ubuntu3) zesty; urgency=medium

  * debian/patches/fix-unaligned-checksum.patch: one more round of fixes
    for armhf.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 20 Feb 2017 18:53:30 -0800

galera-3 (25.3.19-2ubuntu2) zesty; urgency=medium

  * debian/patches/fix-unaligned-checksum.patch: fix to be portable to
    big-endian.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 20 Feb 2017 17:06:57 -0800

galera-3 (25.3.19-2ubuntu1) zesty; urgency=medium

  * debian/patches/fix-unaligned-checksum.patch: avoid unaligned
    dereferencing of a byte array.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 21 Feb 2017 00:35:16 +0000

galera-3 (25.3.19-2) unstable; urgency=low

  * Backport upstream fix for OpenSSL SSL_R_SHORT_READ

 -- Otto Kekäläinen <otto@debian.org>  Fri, 11 Nov 2016 21:38:04 +0200

galera-3 (25.3.19-1) unstable; urgency=low

  * New upstream release 25.3.19
  * Make garb depend on lsb-base as uses /lib/lsb/init-functions

 -- Otto Kekäläinen <otto@debian.org>  Thu, 10 Nov 2016 23:02:48 +0200

galera-3 (25.3.17-1) unstable; urgency=low

  * New upstream release
    - Fixes a GCC6/C++11 compatibility issue (Closes: #812052)

 -- Otto Kekäläinen <otto@debian.org>  Mon, 15 Aug 2016 21:04:56 +0300

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: galera-3
-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
@@ -51,7 +52,7 @@
 Conflicts: garbd-2, garbd2, percona-xtradb-cluster-garbd-2.x
 Breaks: percona-xtradb-cluster-galera-2.x
 Replaces: percona-xtradb-cluster-galera-2.x
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
 Description: Galera arbitrator daemon
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information

## galera-3 25.3.20

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010-2015 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2016 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -13,6 +13,7 @@
 # Set CXXFLAGS to supply C++ compiler options
 # Set LDFLAGS  to *override* linking flags
 # Set LIBPATH  to add non-standard linker paths
+# Set RPATH    to add rpaths
 #
 # Script structure:
 # - Help message
@@ -33,7 +34,7 @@
 bits = ARGUMENTS.get('bits', platform.architecture()[0])
 print 'Host: ' + sysname + ' ' + machine + ' ' + bits
 
-x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386' ])
+x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])
 
 if bits == '32bit':
     bits = 32
@@ -52,6 +53,7 @@
     debug=n             debug build with optimization level n
     build_dir=dir       build directory, default: '.'
     boost=[0|1]         disable or enable boost libraries
+    system_asio=[0|1]   use system asio library, if available
     boost_pool=[0|1]    use or not use boost pool allocator
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
@@ -119,12 +121,14 @@
 
 boost      = int(ARGUMENTS.get('boost', 1))
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
+system_asio= int(ARGUMENTS.get('system_asio', 1))
 ssl        = int(ARGUMENTS.get('ssl', 1))
 tests      = int(ARGUMENTS.get('tests', 1))
+deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.19')
+GALERA_VER = ARGUMENTS.get('version', '3.20')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -172,6 +176,7 @@
 env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
 env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
 env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
+env.Replace(RPATH     = [os.getenv('RPATH',   '')])
 
 # Set -pthread flag explicitly to make sure that pthreads are
 # enabled on all platforms.
@@ -209,24 +214,24 @@
 
 # Common C/CXX flags
 # These should be kept minimal as they are appended after C/CXX specific flags
-env.Append(CCFLAGS = ' -Wall -Wextra -Wno-unused-parameter')
+env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')
 
 # C-specific flags
-env.Append(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
+env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')
 
 # CXX-specific flags
 # Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
 #       adding those after checks
-env.Append(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
+env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated -ansi ')
 if sysname != 'sunos':
-    env.Append(CXXFLAGS = ' -pipe')
+    env.Prepend(CXXFLAGS = '-pipe ')
 
 
 # Linker flags
 # TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
 # static linking have beed addressed
 #
-#env.Append(LINKFLAGS = ' -Wl,--warn-common -Wl,--fatal-warnings')
+#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
 
 #
 # Check required headers and libraries (autoconf functionality)
@@ -374,12 +379,3 @@
         else:
             if not conf.CheckLibWithHeader(libs=[libName],
                                            header=header,
-                                           language='CXX',
-                                           autoadd=autoadd):
-                print 'Error: library %s does not exist' % libName
-                Exit (1)
-            return [libName]
-
-    # Required boost headers/libraries
-    #
-    if boost_pool == 1:

=== debian/changelog ===
galera-3 (25.3.20-1) unstable; urgency=low

  * Update Vcs-* URLs to use secure connections
  * New upstream release 25.3.20
  * Include patch to avoid unaligned access, which fixes the regression
    in the armhf build (Closes: #855657)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 09 Mar 2017 18:41:42 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: galera-3
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
@@ -13,8 +12,8 @@
                libssl-dev,
                scons (>= 2)
 Homepage: http://www.galeracluster.com/
-Vcs-Git: git://anonscm.debian.org/pkg-mysql/galera-3.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-mysql/galera-3.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-mysql/galera-3.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-mysql/galera-3.git
 
 Package: galera-3
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 export DH_VERBOSE=1
+export DEB_BUILD_HARDENING=1
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 # Parallel build support as adviced
 # at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
@@ -17,17 +20,25 @@
 
 # Run tests by default
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	SCONS_ARGS += tests=1
+	SCONS_ARGS += tests=1 deterministic_tests=1
 endif
 
 
 override_dh_auto_build:
+	# Print build env info to help debug builds on different platforms
+	dpkg-architecture
 	@echo $(SCONS_ARGS)
-	scons $(SCONS_ARGS)
+	scons $(SCONS_ARGS) || touch FAIL # Print config.log if build fails
+	@echo '*****************************************'
+	@echo '**  config.log contents for debugging  **'
+	@echo '*****************************************'
+	@cat config.log
+	@echo '*****************************************'
+	if [ -f FAIL ]; then exit 1; fi
 
 # Start earlier than MySQL which has value 19
 override_dh_installinit-arch:
-	dh_installinit --name=garb -- defaults 18 22
+	dh_installinit -n --name=garb -- defaults 18 22
 
 override_dh_strip:
 	dh_strip -pgalera-3 --dbg-package=galera-3-dbg

## galera-3 25.3.22

=== SConstruct ===
--- 
+++ 
@@ -28,6 +28,7 @@
 import os
 import platform
 import string
+import subprocess
 
 sysname = os.uname()[0].lower()
 machine = platform.machine()
@@ -125,10 +126,10 @@
 ssl        = int(ARGUMENTS.get('ssl', 1))
 tests      = int(ARGUMENTS.get('tests', 1))
 deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
-strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
-
-
-GALERA_VER = ARGUMENTS.get('version', '3.20')
+strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
+
+
+GALERA_VER = ARGUMENTS.get('version', '3.22')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -169,6 +170,28 @@
 if link != 'default':
     env.Replace(LINK = link)
 
+# Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
+try:
+    cc_version = subprocess.check_output(
+        env['CC'].split() + ['--version'],
+        stderr=subprocess.STDOUT).splitlines()[0]
+except:
+    # in case "$CC --version" returns an error, e.g. "unknown option"
+    cc_version = 'unknown'
+
+try:
+    cxx_version = subprocess.check_output(
+        env['CXX'].split() + ['--version'],
+        stderr=subprocess.STDOUT).splitlines()[0]
+except:
+    # in case "$CXX --version" returns an error, e.g. "unknown option"
+    cxx_version = 'unknown'
+
+print 'Using C compiler executable: ' + env['CC']
+print 'C compiler version is: ' + cc_version
+print 'Using C++ compiler executable: ' + env['CXX']
+print 'C++ compiler version is: ' + cxx_version
+
 # Initialize CPPFLAGS and LIBPATH from environment to get user preferences
 env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
 env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
@@ -182,10 +205,10 @@
 # enabled on all platforms.
 env.Append(CCFLAGS = ' -pthread')
 
-# Freebsd ports are installed under /usr/local
+# FreeBSD ports are usually installed under /usr/local
 if sysname == 'freebsd' or sysname == 'sunos':
-    env.Append(LIBPATH  = ['/usr/local/lib'])
-    env.Append(CPPFLAGS = ' -I/usr/local/include ')
+    env.Append(LIBPATH = ['/usr/local/lib'])
+    env.Append(CPPPATH = ['/usr/local/include'])
 if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')
 
@@ -360,22 +383,3 @@
     def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
         libName = libBaseName + boost_library_suffix
         if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
-            print "Error: file '%s' does not exist" % configuredLibPath
-            Exit(1)
-        if configuredLibPath == '':
-           for libpath in boost_libpaths:
-               libname = libpath + '/lib%s.a' % libName
-               if os.path.isfile(libname):
-                   configuredLibPath = libname
-                   break
-        if configuredLibPath != '':
-            if not conf.CheckCXXHeader(header):
-                print "Error: header '%s' does not exist" % header
-                Exit (1)
-            if autoadd:
-                conf.env.Append(LIBS=File(configuredLibPath))
-            else:
-                return File(configuredLibPath)
-        else:
-            if not conf.CheckLibWithHeader(libs=[libName],
-                                           header=header,

=== debian/changelog ===
galera-3 (25.3.22-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:21:30 +0000

galera-3 (25.3.22-1) unstable; urgency=low

  * Update download URL and add check authenticity with PGP signature
  * New upstream version 25.3.22
  * Update Debian standards version to to 4.1.1

 -- Otto Kekäläinen <otto@debian.org>  Tue, 21 Nov 2017 11:57:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: galera-3
-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Build-Depends: check,
                debhelper (>= 9),
                libasio-dev,

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-	SCONS_ARGS += -j $(NUMJOBS)
+	SCONS_ARGS += -j$(NUMJOBS)
 	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
 endif
 
@@ -21,6 +21,11 @@
 # Run tests by default
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	SCONS_ARGS += tests=1 deterministic_tests=1
+endif
+
+# Use strict compilation flags (ie -Werror) if requested
+ifneq (,$(filter strict_build_flags,$(DEB_BUILD_OPTIONS)))
+	SCONS_ARGS += strict_build_flags=1
 endif
